Package edu.wisc.game.sql

## Class Game

- java.lang.Object
- - edu.wisc.game.sql.Game

-     public class Game
      extends Object

  A Game object defines how an Episode may be created. A Game object may either consists of a rule set + a predefined board, or of a rule set + the procedure for creating a random board. In the latter case, the procedure for creating a random board may include a random number generator and the parameters of the distribution from which a random board may be drawn (e.g. a color set and the the number of colors, and the same for shapes).

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `boolean` | `crowded` |
    `Board` | `initialBoard` | Only if fixed; null if random
    `int` | `nColors` | If starting with a random board, the number of pieces to use.
    `int` | `nShapes` | If starting with a random board, the number of pieces to use.
    `int` | `randomObjCnt` | If starting with a random board, the number of pieces to use.
    `RuleSet` | `rules` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Game​(RuleSet _rules, Board _initialBoard)` |
    `Game​(RandomRG _random, RuleSet _rules, int _randomObjCnt, int _nShapes, int _nColors, Piece.Shape[] _allShapes, Piece.Color[] _allColors)` | A game with shape-and-color objects used as game pieces
    `Game​(RandomRG _random, RuleSet _rules, int _randomObjCnt, ImageObject.Generator _imageGenerator)` | A game with image-and-properties-based objects used as game pieces
    `Game​(RandomRG _random, RuleSet _rules, int _randomObjCnt, Piece.Shape[] _allShapes, Piece.Color[] _allColors)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `getCrowded()` |
    `void` | `setCrowded​(boolean _crowded)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### rules

          public RuleSet rules

    - #### initialBoard

          public Board initialBoard

      Only if fixed; null if random

    - #### randomObjCnt

          public int randomObjCnt

      If starting with a random board, the number of pieces to use. Only used if initialBoard==null

    - #### nShapes

          public int nShapes

      If starting with a random board, the number of pieces to use. Only used if initialBoard==null

    - #### nColors

          public int nColors

      If starting with a random board, the number of pieces to use. Only used if initialBoard==null

    - #### crowded

          public boolean crowded

  - ### Constructor Detail

    - #### Game

          public Game​(RuleSet _rules,
                      Board _initialBoard)

    - #### Game

          public Game​(RandomRG _random,
                      RuleSet _rules,
                      int _randomObjCnt,
                      Piece.Shape[] _allShapes,
                      Piece.Color[] _allColors)

    - #### Game

          public Game​(RandomRG _random,
                      RuleSet _rules,
                      int _randomObjCnt,
                      int _nShapes,
                      int _nColors,
                      Piece.Shape[] _allShapes,
                      Piece.Color[] _allColors)

      A game with shape-and-color objects used as game pieces

    - #### Game

          public Game​(RandomRG _random,
                      RuleSet _rules,
                      int _randomObjCnt,
                      ImageObject.Generator _imageGenerator)

      A game with image-and-properties-based objects used as game pieces

  - ### Method Detail

    - #### getCrowded

          public boolean getCrowded()

    - #### setCrowded

          public void setCrowded​(boolean _crowded)